#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire800four4xi.py">
#<abstract4xi abstract = "fires to direction four and to distance 800"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire800four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

       
# -------------------------------------------------------------------------------------------------
# SHOT2FOUR - COORDINATE SIGNS OF SHOOT2FOUR4XI: (X + ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2four8004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2four8004xi = {
                1:'101x-165y776z',
                2:'101x-35y792z',
                3:'110x-32y791z',
                4:'114x-166y774z',
                5:'120x-28y790z',
                6:'122x-771y172z',
                7:'127x-166y772z',
                8:'129x-23y789z',
                9:'131x-318y722z',
                10:'138x-17y787z',
                11:'140x-165y769z',
                12:'146x-11y786z',
                13:'150x-317y718z',
                14:'154x-163y767z',
                15:'154x-3y784z',
                16:'162x-765y164z',
                17:'168x-160y765z',
                18:'170x-315y715z',
                19:'182x-156y763z',
                20:'190x-312y711z',
                21:'196x-150y760z',
                22:'203x-757y156z',
                23:'210x-144y758z',
                24:'210x-307y707z',
                25:'213x-451y624z',
                26:'224x-137y755z',
                27:'230x-301y704z',
                28:'237x-129y752z',
                29:'239x-445y619z',
                30:'242x-747y148z',
                31:'250x-119y750z',
                32:'250x-294y700z',
                33:'263x-109y747z',
                34:'266x-437y614z',
                35:'270x-286y696z',
                36:'276x-97y744z',
                37:'282x-735y141z',
                38:'287x-85y741z',
                39:'290x-276y692z',
                40:'292x-428y609z',
                41:'295x-549y500z',
                42:'299x-71y738z',
                43:'309x-265y688z',
                44:'309x-57y735z',
                45:'317x-417y604z',
                46:'319x-42y732z',
                47:'320x-720y133z',
                48:'326x-537y494z',
                49:'328x-253y684z',
                50:'328x-26y728z',
                51:'336x-8y725z',
                52:'343x-404y598z',
                53:'346x-239y679z',
                54:'356x-524y487z',
                55:'358x-704y125z',
                56:'364x-224y675z',
                57:'367x-390y593z',
                58:'381x-208y671z',
                59:'386x-508y481z',
                60:'392x-374y588z',
                61:'395x-685y117z',
                62:'398x-191y667z',
                63:'40x-776y187z',
                64:'413x-172y662z',
                65:'415x-357y582z',
                66:'415x-491y475z',
                67:'428x-152y658z',
                68:'431x-664y109z',
                69:'438x-338y577z',
                70:'442x-132y653z',
                71:'444x-472y468z',
                72:'454x-110y648z',
                73:'460x-318y571z',
                74:'466x-641y101z',
                75:'466x-87y644z',
                76:'471x-451y462z',
                77:'476x-63y639z',
                78:'47x-36y797z',
                79:'481x-297y565z',
                80:'485x-39y634z',
                81:'493x-14y629z',
                82:'498x-429y455z',
                83:'500x-274y560z',
                84:'500x-617y93z',
                85:'519x-250y554z',
                86:'523x-405y449z',
                87:'532x-591y85z',
                88:'536x-224y548z',
                89:'547x-379y442z',
                90:'54x-153y783z',
                91:'553x-198y542z',
                92:'55x-38y797z',
                93:'563x-563y77z',
                94:'567x-170y537z',
                95:'570x-353y435z',
                96:'581x-141y531z',
                97:'592x-324y428z',
                98:'592x-533y69z',
                99:'593x-112y525z',
                100:'603x-81y519z',
                101:'611x-50y512z',
                102:'612x-295y422z',
                103:'618x-18y506z',
                104:'619x-501y61z',
                105:'630x-264y415z',
                106:'645x-469y53z',
                107:'64x-39y796z',
                108:'65x-157y781z',
                109:'669x-434y45z',
                110:'692x-399y37z',
                111:'712x-362y29z',
                112:'728x-261y459z',
                113:'730x-325y21z',
                114:'73x-39y795z',
                115:'746x-286y13z',
                116:'760x-247y5z',
                117:'76x-161y779z',
                118:'81x-775y180z',
                119:'82x-39y794z',
                120:'88x-163y778z',
                121:'92x-37y793z'}#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire800four4xi" usage = "target function for charge8004xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire800four4xi(queue2four, consumer_channel2four, publisher_channel2four):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE800FOUR4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE800FOUR4XI -  QUEUE2FOUR: ", queue2four)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE800FOUR4XI -  CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE800FOUR4XI -  PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE800FOUR4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2four.put(shot2four8004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE800FOUR4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE800FOUR4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE800FOUR4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2four8shot2four8004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2four8shot2four8004xi</nack2put4xi>" 
            
        publisher_channel2four.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE800FOUR4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE800FOUR4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE800FOUR4XI - RETURNING QUEUE OBJECT QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi())  
        # 
            
    return queue2four    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire800four4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                    